### Average monthly daylength for different latitudes, from geosphere by Robert Hijmans ###
## https://www.rdocumentation.org/packages/geosphere/versions/1.5-5/topics/daylength ##
## Input file is the Agri4cast csv with latitudes in decimal degrees, for different locations, 
## prepared via 00_Agri4Cast_grid.R

#install.packages("geosphere")
library("geosphere")

wd <- '/inca_vol1/input_data/crop_pollination/input_intermediate/Agri4Cast_preprocessed/'## path to destination folder (where the outputs are written).
# rd <- wd ## In this case, 'source' (rd) and desintation (wd) folders are the same
 
setwd(wd)
getwd()

## input file: "grid.csv" 

sites <- read.csv ("/data/inca_vol1/input_data/crop_pollination/input_intermediate/Agri4Cast_preprocessed/grid.csv")
str(sites)
names(sites)
length(sites$LATITUDE) ## 8284
l <- length(sites$LATITUDE)
l

l.month <- read.csv ("/data/inca_vol1/input_data/crop_pollination/input_raw/Agri4Cast/MonthLength.csv")
str(l.month)
names(l.month)
l.month

## i = 1

df <- data.frame()
for (i in 1:length(sites$LATITUDE))
{
  lat <- sites$LATITUDE[i]
  long <- sites$LONGITUDE[i]
  grid <- sites$GRID_NO[i]
  print(paste ("GRIDCELL Number = ", i, " of ",l, ", LAT = ", sites$LATITUDE[i], sep = ""))
  dl <- daylength(lat, 1:365)
  #length(dl)
  ll <- l.month$Length
  ##length(ll)
  myindex <- rep(1:12, ll)
  avg.dl <- tapply(dl,INDEX = myindex, FUN = mean )
  class(avg.dl)
  avg.dl
  dl.df <- data.frame("Month_Code" = l.month$Month_Code, "GRID_NO" = rep(grid, length(ll)), "Latitude" = rep(lat, length(ll)),"Longitude" = rep(long, length(ll)), "Length" = l.month$Length, "avg_daylength" = avg.dl)
  df1 <- rbind(df, dl.df)
  df <- df1
}

filename <- ("avg_daylength.csv")
colnames <- c("Month_Code","GRID_NO","Latitude","Longitude", "Length","avg_daylength")
write.table(df, file = filename,  row.names = FALSE, sep = ",", col.names = colnames)
print("end")
##
