### Annual (arithmetic) mean radiation ###
## Input data are Agri4Cast csv rad. files ##

## This example computes annual (arithmetic) mean between 2005 and 2007 ##


rd <- '/data/inca_vol1/input_data/crop_pollination/input_raw/Agri4Cast/Glob_Rad/' ## path to data (radiation data)
wd <- '/data/inca_vol1/input_data/crop_pollination/input_intermediate/Agri4Cast_preprocessed/' ## path to destination folder (where the outputs are written)

setwd(wd)
getwd()
dat <- list.files(path = rd, pattern = ".csv$", full.names = TRUE)
dat
length(dat)
# i = 1
# dat[i]

colnames = c("GRID_NO", "AVG_RAD")
df <- data.frame()
mydat.mean <- data.frame()
#df
##################################
#pick correct files from dat list
files_idx <- c(3)
years <- c('2005','2006,','2007')
##################################


filename <- paste('meanrad_', years[1], years[3],'.csv', sep='')


for (i in files_idx)
     {
       print(dat[i])
       mydat <- read.csv2(dat[i], sep = ";", dec = ".")
       mydat <- subset(mydat, select=-c(LATITUDE,LONGITUDE,ALTITUDE))
       # class(mydat)
       # names(mydat)
       mode(mydat$DAY)
       mydat$DAY <- as.Date(as.character(mydat$DAY), format='%Y%m%d')
       mydat$yr <- format(mydat$DAY, '%Y')
       #mydat$mnth <- format(mydat$DAY, '%m')
       #mydat$dy <- format(mydat$DAY, '%d')
       # names(mydat)
       # str(mydat)
       mydat2.mean <- mydat [mydat$yr ==years[1]|mydat$yr == years[2]|mydat$yr ==years[3],] ## adjust as needed
       rm(mydat)
       mydat.mean <- rbind (mydat.mean, mydat2.mean)
       rm(mydat2.mean)
       
}
       
 # str(mydat.mean)
 # unique(mydat.mean$yr)
 meanrad <- tapply(mydat.mean$RADIATION, INDEX = mydat.mean$GRID_NO, FUN = mean)
 rm(mydat.mean)
 # class(meanrad)
 # head(meanrad)
 # meanrad <- tapply(mydat.mean$RADIATION, INDEX = list(mydat.mean$yr, mydat.mean$GRID_NO), FUN = mean)
 meanrad.df <- data.frame("GRID_NO"= names(meanrad), "AVG_RAD" = meanrad)
 rm(meanrad)
 df <- meanrad.df
 
 rm(meanrad.df)

write.table(df, file = filename,  row.names = FALSE, sep = ",", col.names = colnames)
# write.table(df, file = filename, row.names = F, sep = ",")
print("end")
##
