### Monthly (arithmetic) mean radiation ###
## Input data are Agri4Cast csv radiation files ##

## This example computes monthly (arithmetic) mean between 2005 and 2007 ##
## Useful to set these years ahead, as parameters (e.g. a, b, c) ##

library("plyr")

rd <- '/data/inca_vol1/input_data/crop_pollination/input_raw/Agri4Cast/Glob_Rad/' ## path to data (radiation data)
wd <- '/data/inca_vol1/input_data/crop_pollination/input_intermediate/Agri4Cast_preprocessed/' ## path to destination folder (where the outputs are written)

setwd(wd)
getwd()
dat <- list.files(path = rd, pattern = ".csv$", full.names = TRUE)
dat
length(dat)
l <- length(dat)
df <- data.frame()
mydat.mean <- data.frame()
colnames <- c("Month", "GRID_NO", "AVG_RAD")

##################################
#pick correct files from dat list
files_idx <- c(3)
years <- c('2005','2006,','2007')
##################################



filename <- paste('meanrad_', years[1], years[3],'_monthly.csv', sep='')

for (i in files_idx)
{
  print(dat[i])
  mydat <- read.csv2(dat[i], sep = ";", dec = ".")
  mydat <- subset(mydat, select=-c(LATITUDE,LONGITUDE,ALTITUDE))
  # class(mydat)
  # names(mydat)
  mode(mydat$DAY)
  mydat$DAY <- as.Date(as.character(mydat$DAY), format='%Y%m%d')
  mydat$yr <- format(mydat$DAY, '%Y')
  mydat$mnth <- format(mydat$DAY, '%m')
  #mydat$dy <- format(mydat$DAY, '%d')
  # names(mydat)
  # str(mydat)
  mydat2.mean <- mydat [mydat$yr ==years[1]|mydat$yr == years[2]|mydat$yr ==years[3],] 
  rm(mydat)
  mydat.mean <- rbind (mydat.mean, mydat2.mean)
  rm(mydat2.mean)
}
  
       
# unique(mydat.mean$yr)
# unique(mydat.mean$mnth)
# meanrad <- tapply(mydat.mean$RADIATION, INDEX = mydat.mean$GRID_NO, FUN = mean)
# class(meanrad)
# head(meanrad)
# meanrad <- tapply(mydat.mean$RADIATION, INDEX = list(mydat.mean$GRID_NO, mydat.mean$mnth), FUN = mean)
meanrad.t <- aggregate(mydat.mean$RADIATION, list(mydat.mean$mnth, mydat.mean$GRID_NO),FUN= mean)
rm(mydat.mean)
df <- rename(meanrad.t, c("Group.1"="Month_Code", "Group.2"="GRID_NO", "x" = "AVG_RAD"))
rm(meanrad.t)

write.table(df, file = filename,  row.names = FALSE, sep = ",")
# write.table(df, file = filename, row.names = F, sep = ",")
print("end")

mydat <- read.csv(filename)
names(mydat)
class(mydat)
dim(mydat)

## Removing duplicated records; these records come from grid cells covering more than one country
dup <- mydat[duplicated(mydat), ]
dim(dup)[1]
nodup <- mydat[!duplicated(mydat), ]
dim(nodup)[1]
d <- dim(nodup)[1]
d
d12 <- d/12 ## division by the number of months
d12
lgrid <- length(unique(mydat$GRID_NO))
lgrid
d12 - lgrid ## same length. So now there arerent any duplicated records

nameunique <- paste("unique",filename, sep = "_")
write.table(nodup, file = nameunique,  row.names = FALSE, sep = ",")
print("end")
##
