### Monthly (arithmetic) mean air temperature ###
## Input data are Agri4Cast csvair temperature files ##

## This example computes monthly (arithmetic) mean between 2005 and 2007 ##
## Useful to set these years ahead, as parameters (e.g. a, b, c) ##
library("plyr")

rd <- '/data/inca_vol1/input_data/crop_pollination/input_raw/Agri4Cast/Tmean/' ## path to data (air temperature data)
wd <- '/data/inca_vol1/input_data/crop_pollination/input_intermediate/Agri4Cast_preprocessed/' ## path to destination folder (where the outputs are written)

setwd(wd)
getwd()
dat <- list.files(path = rd, pattern = ".csv$", full.names = TRUE)
dat
length(dat)

# colnames = c("GRID_NO", "TEMPERATURE_AVG")
mydat.mean <- data.frame()
df <- data.frame()
colnames <- c("Month_Code", "GRID_NO", "Avg_T")
#df
##################################
#pick correct files from dat list
files_idx <- c(3)
years <- c('2005','2006,','2007')
##################################



filename <- paste('meantemp_', years[1], years[3],'_monthly.csv', sep='')

#i = 1
for (i in files_idx)
{
  print(dat[i])
  mydat <- read.csv2(dat[i], sep = ";", dec = ".")
  mydat <- subset(mydat, select=-c(LATITUDE,LONGITUDE,ALTITUDE))
  
  # class(mydat)
  # names(mydat)
  mode(mydat$DAY)
  mydat$DAY <- as.Date(as.character(mydat$DAY), format='%Y%m%d')
  mydat$yr <- format(mydat$DAY, '%Y')
  mydat$mnth <- format(mydat$DAY, '%m')
  #mydat$dy <- format(mydat$DAY, '%d')
  # names(mydat)
  # str(mydat)
  mydat2.mean <- mydat [mydat$yr ==years[1]|mydat$yr == years[2]|mydat$yr ==years[3],] ## adjust as needed
  rm(mydat)
  mydat.mean <- rbind (mydat.mean, mydat2.mean)
  rm(mydat2.mean)
}

# str(mydat.mean)
# unique(mydat.mean$yr)
# unique(mydat.mean$mnth)
# meantemp <- tapply(mydat.mean$TEMPERATURE_AVG, INDEX = mydat.mean$GRID_NO, FUN = mean)
# class(meantemp)
# head(meantemp)
# meantemp <- tapply(mydat.mean$TEMPERATURE_AVG, INDEX = list(mydat.mean$GRID_NO, mydat.mean$mnth), FUN = mean)
meantemp.t <- aggregate(mydat.mean$TEMPERATURE_AVG, list(mydat.mean$mnth, mydat.mean$GRID_NO),FUN= mean)
meantemp <- rename(meantemp.t, c("Group.1"="Month", "Group.2"="GRID_NO", "x" = "TEMPERATURE_AVG"))
df1 <- rbind(df, meantemp)
df <- df1

write.table(df, file = filename,  row.names = FALSE, sep = ",")
# write.table(df, file = filename, row.names = F, sep = ",")
print("end")

mydat <- read.csv(filename)
names(mydat)
class(mydat)
dim(mydat)

## Removing duplicated records; these records come from grid cells covering more than one country
dup <- mydat[duplicated(mydat), ]
dim(dup)[1]
nodup <- mydat[!duplicated(mydat), ]
dim(nodup)[1]
d <- dim(nodup)[1]
d
d12 <- d/12 ## division by the number of months
d12
lgrid <- length(unique(mydat$GRID_NO))
lgrid
d12 - lgrid ## same length. So now there areren't any duplicated records

nameunique <- paste("unique",filename, sep = "_")
write.table(nodup, file = nameunique,  row.names = FALSE, sep = ",")
print("end")
##
