import pandas as pd
import geopandas as gpd
import numpy as np
import os

current_path = os.getcwd()


old_p = os.path.join(current_path,"correctMissingData")
new_p = os.path.join(current_path,"final_csvs_overnightstays")
out_p = os.path.join(current_path,"checkImpactChanges")
years = [2000,2006,2012,2018,2021]

for yr in years:
    df_old = pd.read_csv(os.path.join(old_p,"overnight_stays_{}.csv".format(yr)))
    df_new = pd.read_csv(os.path.join(new_p,"overnight_stays_{}.csv".format(yr)))
    df_old["change"] = df_old["OvernightStays"] - df_new["OvernightStays"]
    df_old = df_old[df_old["change"] > 1]
    total_visitsEU27 = df_new["OvernightStays"].sum()
    df_old["change_percent"] = df_old["change"]/total_visitsEU27*100
    total_percent = df_old["change_percent"].sum()
    print("year: {} - percent sum: {}".format(yr,total_percent))
    df_old.to_csv(os.path.join(out_p, "changes{}.csv".format(yr)),
                          index=False,
                          header=True)

    print("a")