import pandas as pd
import geopandas as gpd
import numpy as np
import os

current_path = os.getcwd()

# nuts data shapes
nuts2021 = r"C:\repos\inca\src\inca\data\NUTS_RG_03M_2021_3035_LEVL012_EU2020.gpkg"
nuts2013 = r"C:\repos\inca_geopandas\NUTS_RG_03M_2013_3035.shp\NUTS_RG_03M_2013_3035.shp"
nuts2016 = r"C:\repos\inca_geopandas\NUTS_RG_03M_2016_3035.shp\NUTS_RG_03M_2016_3035.shp"

nutsshapes = {
    2013: nuts2013,
    2016: nuts2016,
    2021: nuts2021
}

shapefiles = dict()
for year, path in nutsshapes.items():
    shapefiles[year] = gpd.read_file(path)


years2process_unproc = [2000,2006,2012,2018,2021]
file2process = "data_nuts_overnight/Voorbereiding inputtabellen {} nin2.xlsx"

data_unproc_dict = dict()
for year in years2process_unproc:
    if year != 2021:
        file2load = file2process.format(year)
    else:
        file2load = "data_nuts_overnight/Voorbereiding inputtabellen 2021 nin2d.xlsx"
    data_unproc = pd.read_excel(file2load,
                         sheet_name="Basistabel",
                         skiprows=4)
    if year in [2000,2006,2012]:
        data_unproc = data_unproc.iloc[:, :-2]

        # rename cols
        data_unproc.columns=["nutscode",
                    "nutsname",
                    "foreign",
                    "reporting",
                    "total"]

    elif year == 2018:
        data_unproc = data_unproc.iloc[:, [0,1,2,4,6]]

        # rename cols
        data_unproc.columns=["nutscode",
                    "nutsname",
                    "foreign",
                    "total",
                    "reporting"]
    elif year == 2021:
        data_unproc = data_unproc.iloc[:, [1,2,3,7,11]]

        # rename cols
        data_unproc.columns = ["nutscode",
                        "nutsname",
                        "foreign",
                        "reporting",
                        "total"]
    # check for dupes
    data_unproc['DuplicatesCount'] = data_unproc.groupby('nutsname')['nutsname'].transform('count')
    data_unproc['CNTRY'] = data_unproc['nutscode'].str.replace(r'\d', '')

    data_unproc_dict[year] = data_unproc

    print("a")